## advligorts 5.5.2

=== CMakeLists.txt ===
project(daqd-trunk)
cmake_minimum_required(VERSION 3.12)

enable_testing()

# DEFINE BUILD_ON_BOOT from commandline when building on a typical puppet configured boot server
# This will cut out sections that depend on packages not usually installed on such bootservers.

FIND_PROGRAM(BISON_PROG bison)
FIND_PROGRAM(FLEX_PROG flex)

SET( CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${PROJECT_SOURCE_DIR}/config/cmake" )
message("cmake modules" ${CMAKE_MODULE_PATH})

INCLUDE(CheckCXXCompilerFlag)
INCLUDE(CheckIncludeFile)
INCLUDE(CheckIncludeFileCXX)
INCLUDE(CheckFunctionExists)
INCLUDE(CheckCXXSourceCompiles)
INCLUDE(FindThreads)
INCLUDE(Sanitizers)
INCLUDE(Cpp11)
INCLUDE(Integration)
FIND_PACKAGE(PkgConfig)
FIND_PACKAGE(ClockGetTime)
FIND_PACKAGE(EPICSBase REQUIRED)


if( NOT BUILD_ON_BOOT ) #Exclude some packages/build when building on boot server
    FIND_PACKAGE(FrameCPP REQUIRED)
    FIND_PACKAGE(RapidJSON)
    FIND_PACKAGE(yaml-cpp)
    find_package(pybind11)
    FIND_PACKAGE(Python3)
    FIND_PROGRAM(GOLANG go
            HINTS /usr/bin)
    find_program(CARGO cargo)

    if( NOT DEFINED Python3_SITEARCH)
        MESSAGE(FATAL_ERROR "Python 3 library installation directory was not found.")
    endif()


    # check python3 SITEARCH is found
    # the Python3_SITEARCH variable tells us where to install architecture dependent
    # python packages.
    # This is converted to a relative install path called Python3_ARCH_INSTALL_DIR,
    # needed for pybind11 packages.
    #
    # Python3_SITELIB gives the install path for architecture independent packages
    # if those are needed, then Python3_SITELIB should get the same treatment as Python3_SITEARCH.
    # Python3_LIB_INSTALL_DIR should be created and used for those packages.
    if( NOT DEFINED Python3_SITEARCH)
        MESSAGE(FATAL_ERROR "Python 3 library installation directory was not found.")
    endif()

    # generate relative python install directories
    get_filename_component(Python3_PKG_ARCH_DIR ${Python3_SITEARCH} NAME)
    get_filename_component(Python3_ARCH_BASE_DIR ${Python3_SITEARCH} DIRECTORY)
    get_filename_component(Python3_PYTHON_ARCH_DIR ${Python3_ARCH_BASE_DIR} NAME)
    SET(Python3_ARCH_INSTALL_DIR lib/${Python3_PYTHON_ARCH_DIR}/${Python3_PKG_ARCH_DIR})

    MESSAGE(STATUS "Python3 version: ${Python3_VERSION}")
    MESSAGE(STATUS "Python3 site arch: ${Python3_SITEARCH}")
    MESSAGE(STATUS "Python3 arch install dir: ${Python3_ARCH_INSTALL_DIR}")
    MESSAGE(STATUS "Python3 include dirs: ${Python3_INCLUDE_DIRS}")
    MESSAGE(STATUS "Python3 libraries: ${Python3_LIBRARIES}")
    MESSAGE(STATUS "Python3 library dirs: ${Python3_LIBRARY_DIRS}")
    MESSAGE(STATUS "Python3 sitelib: ${Python3_SITELIB}")
    MESSAGE(STATUS "Python3 development found: ${Python3_Development_FOUND}")

endif()

FIND_PACKAGE(NDS2Client)
FIND_PACKAGE(Boost COMPONENTS filesystem system)
FIND_PACKAGE(RPC)


if (PUB_SUB_LOCAL)
    message("Using a local source copy of cds-pubsub")
    add_subdirectory("${PUB_SUB_LOCAL}" cds-pubsub)
    add_library(cds::pub_sub ALIAS pub_sub)
    add_library(cds::pub_sub_asan ALIAS pub_sub_asan)
    set(libcds-pubsub_FOUND "true")
else (PUB_SUB_LOCAL)
    FIND_PACKAGE(libcds-pubsub)
endif (PUB_SUB_LOCAL)


CHECK_CXX_SOURCE_COMPILES("#include <iostream>
#include <FlexLexer.h>
struct TestLexer: public yyFlexLexer {
	TestLexer(std::ifstream* arg_yyin = 0, std::ofstream* arg_yyout = 0)
	{ std::ostream& tmp = yyout; }
};
int main(int argc, char **argv)
{ return 1; }" FLEX_USES_IOSTREAM_REF)

CHECK_CXX_COMPILER_FLAG(-Wno-deprecated-declarations CAN_AVOID_DEPR_DECL)
if(CAN_AVOID_DEPR_DECL)
    SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-deprecated-declarations")
endif(CAN_AVOID_DEPR_DECL)

CHECK_INCLUDE_FILE(FlexLexer.h HAVE_FLEXLEXER_H)
CHECK_INCLUDE_FILE(arpa/inet.h HAVE_ARPA_INET_H)
CHECK_INCLUDE_FILE(assert.h HAVE_ASSERT_H)
CHECK_INCLUDE_FILE(ctype.h HAVE_CTYPE_H)
CHECK_INCLUDE_FILE(errno.h HAVE_ERRNO_H)
CHECK_INCLUDE_FILE(fcntl.h HAVE_FCNTL_H)
CHECK_INCLUDE_FILE(fstream.h HAVE_FSTREAM_H)
CHECK_INCLUDE_FILE(iostream.h HAVE_IOSTREAM_H)
CHECK_INCLUDE_FILE(limits.h HAVE_LIMITS_H)
CHECK_INCLUDE_FILE(math.h HAVE_MATH_H)
CHECK_INCLUDE_FILE(netinet/in.h HAVE_NETINET_IN_H)
CHECK_INCLUDE_FILE(pthread.h HAVE_PTHREAD_H)
CHECK_INCLUDE_FILE(signal.h HAVE_SIGNAL_H)
CHECK_INCLUDE_FILE(stdio.h HAVE_STDIO_H)
CHECK_INCLUDE_FILE(stdlib.h HAVE_STDLIB_H)
CHECK_INCLUDE_FILE(stream.h HAVE_STREAM_H)
CHECK_INCLUDE_FILE(string.h HAVE_STRING_H)
CHECK_INCLUDE_FILE(sys/socket.h HAVE_SYS_SOCKET_H)
CHECK_INCLUDE_FILE(sys/types.h HAVE_SYS_TYPES_H)
CHECK_INCLUDE_FILE(time.h HAVE_TIME_H)
CHECK_INCLUDE_FILE(unistd.h HAVE_UNISTD_H)
CHECK_INCLUDE_FILE(regexp.h HAVE_REGEXP_H)
CHECK_INCLUDE_FILE(regex.h HAVE_REGEX_H)



CHECK_FUNCTION_EXISTS(strchr HAVE_STRCHR)
CHECK_FUNCTION_EXISTS(memcpy HAVE_MEMCPY)
CHECK_FUNCTION_EXISTS(fchdir HAVE_FCHDIR)

add_compile_options(-g3)

add_subdirectory(src)

if( NOT DEFINED BUILD_ON_ROOT )
    add_subdirectory(test)
endif()

=== src/CMakeLists.txt ===
add_subdirectory(catch)
add_subdirectory(cds-shmem)
add_subdirectory(drv)
add_subdirectory(simpleargs)
add_subdirectory(epics)
add_subdirectory(gds)

if( NOT BUILD_ON_BOOT )
    add_subdirectory(daqd)
    add_subdirectory(dolphin_daemon)
    #add_subdirectory(dv)
    add_subdirectory(nds)
    add_subdirectory(run_number)
    add_subdirectory(local_dc)
    add_subdirectory(fe_stream_test)
    add_subdirectory(pub_sub_stream)
    add_subdirectory(rust)
endif()

add_subdirectory(simple_pv)

add_subdirectory(util)
add_subdirectory(include)
add_subdirectory(python)

=== test/CMakeLists.txt ===
add_test(
        NAME test-model-build
        COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/run "${CMAKE_CURRENT_SOURCE_DIR}" build
        WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
)

add_test(
        NAME test-model-install
        COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/run "${CMAKE_CURRENT_SOURCE_DIR}" install
        WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
)

add_test(
        NAME test-model-startstop
        COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/run "${CMAKE_CURRENT_SOURCE_DIR}" startstop
        WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
)

add_subdirectory(parts_tests)

=== src/catch/CMakeLists.txt ===
if (TARGET catch2)
    message("Catch2 already defined, assuming this is from an external  include")
else (TARGET catch2)
    add_library(catch2 INTERFACE)
    target_include_directories(catch2 INTERFACE ${CMAKE_CURRENT_SOURCE_DIR})
endif (TARGET catch2)

=== src/cds-shmem/CMakeLists.txt ===
add_library(cds-shmem STATIC cds-shmem.c)
target_include_directories(cds-shmem PUBLIC
        ${CMAKE_CURRENT_SOURCE_DIR}/../include
        ${CMAKE_CURRENT_SOURCE_DIR}
)
target_include_directories(cds-shmem PRIVATE ${CMAKE_CURRENT_SOURCE_DIR}/mbuf)
target_compile_options(cds-shmem PRIVATE -fPIC)
target_link_libraries(cds-shmem PUBLIC rt)
install(TARGETS cds-shmem DESTINATION lib)
install(FILES cds-shmem.h DESTINATION include/advligorts)

add_library(driver::shmem ALIAS cds-shmem)

=== src/daqd/CMakeLists.txt ===
FIND_PROGRAM(UNAME_PROG uname)
FIND_PROGRAM(DATE_PROG date)

FIND_PATH(FLEX_LEXER_PATH FlexLexer.h
		HINTS /usr/include)
message("Flex lexer path = '${FLEX_LEXER_PATH}'")
if (NOT FLEX_LEXER_PATH)
	message(FATAL_ERROR "FlexLexer.h is not found.  On debian this is in the libfl-dev package")
endif (NOT FLEX_LEXER_PATH)

INCLUDE(Cpp11)
INCLUDE(CheckCXXSourceCompiles)

configure_file(config.h.cmake ${CMAKE_CURRENT_BINARY_DIR}/config.h)

set(__daqd_tmp_CMAKE_REQUIRED_FLAGS ${CMAKE_REQUIRED_FLAGS})
set(CMAKE_REQUIRED_FLAGS ${CPP11_FLAG})
check_cxx_source_compiles("#include<array>
int main() { return 0; }" DAQD_CAN_BUILD_DAQD_SHMEM)
set(CMAKE_REQUIRED_FLAGS ${__daqd_tmp_CMAKE_REQUIRED_FLAGS})

set_source_files_properties(listener.cc daqd.cc
	PROPERTIES OBJECT_DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/y.tab.h)

execute_process(COMMAND uname -a
        OUTPUT_VARIABLE DAQD_UNAME)
execute_process(COMMAND date
        OUTPUT_VARIABLE DAQD_DATE)

string(REPLACE "#" "" DAQD_UNAME ${DAQD_UNAME})
string(REPLACE "\n" "" DAQD_UNAME ${DAQD_UNAME})

string(REPLACE "\n" "" DAQD_DATE ${DAQD_DATE})
set(DAQD_BUILD_INFO_DEFINES -DSERVER_VERSION=\"2.0\"
        -DPRODUCTION_MACHINE=\"${DAQD_UNAME}\"
        -DPRODUCTION_DATE=\"${DAQD_DATE}\")

set(CDS_GDSFLAGS "-DGDS_TESTPOINT_SUPPORT")

add_custom_command(OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/comm-lex.cc
        COMMAND ${FLEX_PROG} -+ -o ${CMAKE_CURRENT_BINARY_DIR}/comm-lex.cc ${CMAKE_CURRENT_SOURCE_DIR}/comm-lex.l
        DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/comm-lex.l
        MAIN_DEPENDENCY ${CMAKE_CURRENT_SOURCE_DIR}/comm-lex.l
        )

add_custom_command(OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/comm.cc ${CMAKE_CURRENT_BINARY_DIR}/y.tab.h
        COMMAND ${BISON_PROG} -o ${CMAKE_CURRENT_BINARY_DIR}/comm.cc -d ${CMAKE_CURRENT_SOURCE_DIR}/comm.y
        COMMAND ${CMAKE_COMMAND} -E rename ${CMAKE_CURRENT_BINARY_DIR}/comm.hh ${CMAKE_CURRENT_BINARY_DIR}/y.tab.h
        MAIN_DEPENDENCY ${CMAKE_CURRENT_SOURCE_DIR}/comm.y
        DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/comm.y
        WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
        )

########
# The daqd build is made from several static libraries
# the libraries are used to group items with similar build settings together
# and are not meant to be exported.
#######
# Common source lists
#######

set(DAQD_GDS_SRC
        gds.cc
        )

if (${DAQD_CAN_BUILD_DAQD_SHMEM})
##########
## generic daq with shmem
####
add_library(dc_gds_shmem STATIC gds.cc)
target_compile_definitions(dc_gds_shmem PRIVATE
		${DAQD_BUILD_INFO_DEFINES} -DUNIX -Dlinux -DUNIX -Dlinux
		-D_REENTRANT -DNO_RTL=1 -DDAQD_CPP11 -DUSE_FRAMECPP_VERSION
		-DLIGO_GDS
		-D_TP_DAQD
		-DARCHIVE=\"${CMAKE_CURRENT_SOURCE_DIR}/../gds\"
		-DDAQD_BUILD_SHMEM)
target_include_directories(dc_gds_shmem PUBLIC
		${CMAKE_CURRENT_SOURCE_DIR}/../include
		${CMAKE_CURRENT_SOURCE_DIR}
		${CMAKE_CURRENT_BINARY_DIR}
		${RPC_INCLUDE_DIRS}
        ${CMAKE_SOURCE_DIR}/src/gds/rpc
        ${CMAKE_SOURCE_DIR}/src/gds/awgtpman
		)
target_compile_options(dc_gds_shmem PUBLIC
		-fno-common
		-Wno-deprecated
		-Wno-write-strings
		)
target_link_libraries(dc_gds_shmem PRIVATE
        testpoint
		gds::daqd
		ldastools::framecpp
		${RPC_LIBRARIES}
		)

add_library(crc32 STATIC
		checksum_crc32.cc)
target_include_directories(crc32 PUBLIC ${CMAKE_CURRENT_SOURCE_DIR})

add_executable(daqd
		archive.cc
		profiler.cc
		filesys.cc
		epics_pvs.cc
		trend.cc
		net_writer.cc
		circ.cc
		daqd_config.cc
		daqd_config_impl.cc
		declarative_config.cc
		declarative_services.cc
		framesend.cc
		gdsmutex.cc
		epicsServer.cc
		exServer.cc
		exScalarPV.cc
		exVectorPV.cc
		exPV.cc
		exChannel.cc
		framerecv.cc
		listener.cc
		daqd.cc
		comm_impl.cc
        daqd_thread.cc
		network_helpers.cc
		../include/daq_core.h
		${CMAKE_CURRENT_BINARY_DIR}/comm.cc
		${CMAKE_CURRENT_BINARY_DIR}/comm-lex.cc
		producer_shmem.cc)

target_compile_definitions(daqd PUBLIC
		${DAQD_BUILD_INFO_DEFINES} -DUNIX -Dlinux -DUNIX -Dlinux
		-D_REENTRANT -DNO_RTL=1 -DDAQD_CPP11 -DUSE_FRAMECPP_VERSION
		-DDAQD_BUILD_SHMEM
		)
target_include_directories(daqd PUBLIC
		${CMAKE_CURRENT_BINARY_DIR}
		${CMAKE_CURRENT_SOURCE_DIR}
		${CMAKE_CURRENT_SOURCE_DIR}/../include
		${RPC_INCLUDE_DIRS}
        ${CMAKE_SOURCE_DIR}/src/gds/rpc
		)
target_link_libraries(daqd PUBLIC
		dc_gds_shmem
		run_number::run_number
		# ca Com cas gdd
		epics::cas
		epics::ca
		epics::gdd
		#${EPICS_BASE_CA_LIBS} ${EPICS_BASE_CAS_LIBS}
		ldastools::framecpp
		driver::shmem
		driver::ini_parsing
		crc32
		yaml-cpp
		${CMAKE_THREAD_LIBS_INIT}
		${RPC_LIBRARIES}
		)

install(TARGETS daqd DESTINATION bin)
install(PROGRAMS util/daq_wiper.py
		DESTINATION bin
		RENAME daq_wiper)
install(PROGRAMS util/checkdaqconfig.py
		DESTINATION bin
		RENAME checkdaqconfig)

add_executable(test_daqd_unit_tests
		tests/test_main.cc
		tests/test_daqd_cmask_t.cc
		tests/test_shmem_recv.cc
		tests/test_daqd_thread.cc
		tests/test_daqd_channel_hashes.cc
		tests/test_network_helpers.cc
		tests/test_raii.cc
        daqd_thread.cc
		network_helpers.cc
		tests/test_declarative_config.cc
		daqd_config.cc
		declarative_config.cc
		declarative_services.cc
		)
target_compile_options(test_daqd_unit_tests PUBLIC "-fsanitize=address")
target_include_directories(test_daqd_unit_tests PUBLIC
		${CMAKE_CURRENT_SOURCE_DIR}
		../include
		${CMAKE_CURRENT_BINARY_DIR})
target_link_libraries(test_daqd_unit_tests PUBLIC
		asan
		catch2
		ldastools::framecpp
		driver::shmem
		yaml-cpp
		${CMAKE_THREAD_LIBS_INIT})
add_test(NAME test_daqd_unit_tests
		COMMAND test_daqd_unit_tests
		WORKING_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}")

add_executable(generate_crc32_table checksum_crc32.cc)
target_compile_definitions(generate_crc32_table PRIVATE CRC32_MAIN)
target_compile_definitions(generate_crc32_table PRIVATE CRC32_AUTO_GENERATE_TABLE)

add_executable(test_crc32 checksum_crc32.cc
		tests/test_checksum_crc32.cc
		../drv/crc.c)
target_compile_definitions(test_crc32 PRIVATE CRC32_AUTO_GENERATE_TABLE)
target_include_directories(test_crc32 PUBLIC ${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_CURRENT_SOURCE_DIR}/../include/)
target_link_libraries(test_crc32 PUBLIC catch2)
add_test(NAME test_crc32
		COMMAND test_crc32
		WORKING_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}")

add_executable(test_crc32_table_lookup
		checksum_crc32.cc
		tests/test_checksum_crc32.cc
		../drv/crc.c)
target_include_directories(test_crc32_table_lookup PUBLIC ${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_CURRENT_SOURCE_DIR}/../include/)
target_link_libraries(test_crc32_table_lookup PUBLIC catch2)
add_test(NAME test_crc32_table_lookup
		COMMAND test_crc32_table_lookup
		WORKING_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}")

integration_test(
		NAME test_daqd_stop_on_bad_broadcast_list
		SCRIPT "tests/test_daqd_stop_on_bad_broadcast_list.py"
		RESOURCE "tests/daqdrc_broadcast_test"
	)

integration_test(
        NAME test_daqd_stop_on_bad_broadcast_list_declarative
        SCRIPT "tests/test_daqd_stop_on_bad_broadcast_list_declarative.py"
        RESOURCE "tests/broadcast_test.yaml"
    )

integration_test(
		NAME test_daqd_stop_on_duplicate_channel_list
		SCRIPT "tests/test_daqd_stop_on_duplicate_channel_list.py"
		RESOURCE "tests/daqdrc_live_test"
    )

integration_test(
		NAME test_daqd_timing_glitches_issue_294
		SCRIPT "tests/test_daqd_timing_glitches_issue_294.py"
	    RESOURCE "tests/daqdrc_live_test"
	)


if (libNDS2Client_FOUND)

	integration_test(
			NAME test_daqd_stop_on_stream_jump
			SCRIPT "tests/test_daqd_stop_on_stream_jump.py"
			RESOURCE "tests/daqdrc_live_test"
	)

	configure_file(tests/daqdrc_live_test ${CMAKE_CURRENT_BINARY_DIR}/daqdrc_live_test COPYONLY)
	#configure_file(tests/test_daqd_live_nds.sh.in ${CMAKE_CURRENT_BINARY_DIR}/test_daqd_live_nds.sh @ONLY)

	#add_test(NAME test_daqd_live_nds
	#		COMMAND /bin/bash ./test_daqd_live_nds.sh
	#		WORKING_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}")

	integration_test(

	    NAME test_daqd_live_nds
	    SCRIPT "tests/test_daqd_live_nds.py"
        RESOURCE "tests/daqdrc_live_test"
	)

	integration_test(

	    NAME test_daqd_live_nds_posix_shmem
	    SCRIPT "tests/test_daqd_live_nds_posix_shmem.py"
        RESOURCE "tests/daqdrc_live_posix_shmem_test"
	)
	integration_test(

	    NAME test_daqd_nds_connections
	    SCRIPT "tests/test_daqd_nds_connections.py"
        RESOURCE "tests/daqdrc_live_test"
	)


	#configure_file(tests/daqdrc_live_posix_shmem_test ${CMAKE_CURRENT_BINARY_DIR}/daqdrc_live_posix_shmem_test COPYONLY)
	#configure_file(tests/test_daqd_live_nds_posix_shmem.sh.in ${CMAKE_CURRENT_BINARY_DIR}/test_daqd_live_nds_posix_shmem.sh @ONLY)

	#add_test(NAME test_daqd_live_nds_posix_shmem
	#		COMMAND /bin/bash ./test_daqd_live_nds_posix_shmem.sh
	#		WORKING_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}")

	add_test(NAME test_daqd_stall_signal
			COMMAND "${Python3_EXECUTABLE}" -B "${CMAKE_CURRENT_SOURCE_DIR}/tests/test_daqd_stall_signal.py"
			WORKING_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}")

	integration_test(
			NAME test_daqd_nds
			SCRIPT "tests/test_daqd_nds.py"
			RESOURCE "tests/daqdrc_nds_test"
	)

	integration_test(
			NAME test_daqd_nds_declarative
			SCRIPT "tests/test_daqd_nds_declarative.py"
			RESOURCE "tests/nds_test.yaml"
	)

	add_executable(test_nds1_connections tests/test_nds1_connections.cc)
	target_link_libraries(test_nds1_connections PUBLIC nds2client::cxx
		${CMAKE_THREAD_LIBS_INIT})

	configure_file(tests/test_daqd_nds_connections.sh.in ${CMAKE_CURRENT_BINARY_DIR}/test_daqd_nds_connections.sh @ONLY)

	#add_test(NAME test_daqd_nds_connections
	#		COMMAND /bin/bash ./test_daqd_nds_connections.sh
	#		WORKING_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}")

endif (libNDS2Client_FOUND)

endif(${DAQD_CAN_BUILD_DAQD_SHMEM})

=== src/dolphin_daemon/CMakeLists.txt ===
project (dolphin_daemon)

add_executable(${PROJECT_NAME} ${CMAKE_CURRENT_SOURCE_DIR}/src/main.cpp ${CMAKE_CURRENT_SOURCE_DIR}/src/DolphinKernelProxy.cpp)

target_compile_options(${PROJECT_NAME} PRIVATE -std=gnu++17)

target_include_directories(${PROJECT_NAME}
    PRIVATE
    ${CMAKE_CURRENT_SOURCE_DIR}/include/
    ${CMAKE_CURRENT_SOURCE_DIR}/../include/
    )

target_link_libraries(${PROJECT_NAME}
    PRIVATE
    fmt
    pthread
    )


install(TARGETS ${PROJECT_NAME} DESTINATION bin)

=== src/drv/CMakeLists.txt ===
add_subdirectory(mbuf/mbuf_probe)
add_subdirectory(mbuf/userapace_test)
add_subdirectory(gpstime/tests)
add_subdirectory(gpstime/gps_module_utils)

if( NOT BUILD_ON_BOOT )
    add_subdirectory(python)
endif()

add_library(ini_parsing STATIC param.c crc.c)
target_include_directories(ini_parsing PUBLIC
        ${CMAKE_CURRENT_SOURCE_DIR}/../include)
add_library(driver::ini_parsing ALIAS ini_parsing)

add_library(gpsclock STATIC gpsclock.c)
target_include_directories(gpsclock PUBLIC ${CMAKE_CURRENT_SOURCE_DIR}/../include)
add_library(driver::gpsclock ALIAS gpsclock)

=== src/epics/CMakeLists.txt ===
add_subdirectory(seq)
add_subdirectory(edcu)

=== src/fe_stream_test/CMakeLists.txt ===
add_library(fe_stream_generator STATIC
        fe_stream_generator.cc
        fe_stream_generator.hh
        str_split.cc
        str_split.hh
        fe_generator_support.hh
        fe_generator_support.cc)
target_include_directories(fe_stream_generator PUBLIC ${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_CURRENT_SOURCE_DIR}/../include)

add_executable(fe_stream_check
        fe_stream_check.cc
        )
target_link_libraries(fe_stream_check
        PRIVATE
        fe_stream_generator
        rt
        driver::shmem
        Threads::Threads)

add_executable(fe_check fe_check.cc)
target_link_libraries(fe_check
        PRIVATE
        rt
        driver::shmem)

install(TARGETS fe_stream_check
        DESTINATION bin)
add_subdirectory(fe_simulation)


if (libNDS2Client_FOUND)

add_executable(fe_stream_check_nds fe_stream_check_nds.cc)
target_link_libraries(fe_stream_check_nds
        PRIVATE
        fe_stream_generator
        nds2client::cxx
        driver::shmem
        Threads::Threads
        Boost::filesystem
        Boost::system)

add_executable(fe_stream_check_edcu_nds fe_stream_check_edcu_nds.cc)
target_include_directories(fe_stream_check_edcu_nds PUBLIC ${CMAKE_CURRENT_SOURCE_DIR}/../include)
target_link_libraries(fe_stream_check_edcu_nds
        PRIVATE
        fe_stream_generator
        nds2client::cxx
        driver::shmem)

install(TARGETS fe_stream_check_nds DESTINATION bin)

endif (libNDS2Client_FOUND)

=== src/gds/CMakeLists.txt ===

#setup any rpc generation

if(APPLE)
    SET( RPCFLAGS -N -C -M -DLIGO_GDS -DGDS_NO_EPICS ${max_chnname_size})
    FIND_PROGRAM(RPCGEN_PROG rpcgen-mt)
    add_compile_definitions(
            u_int=unsigned\ int
            u_long=unsigned\ long
            u_short=unsigned\ short
    )
elseif(UNIX)
    SET( RPCFLAGS -C -N -M -DLIGO_GDS -DGDS_NO_EPICS ${max_chnname_size})
    FIND_PROGRAM(RPCGEN_PROG rpcgen)
endif()

MESSAGE("Found rpcgen at ${RPCGEN_PROG}")

SET (GDS_GEN_RPC_HDRS "")
SET (RPC_BASE gdsrsched rawgapi rtestpoint)
SET (RPC_OUTPUT_DIR ${CMAKE_BINARY_DIR}/rpc_output)

set_property(GLOBAL PROPERTY RPC_OUT_FILES "" )
set_property(GLOBAL PROPERTY RPC_TARGETS "" )

FILE(MAKE_DIRECTORY ${RPC_OUTPUT_DIR})

#    add_compile_definitions(
#	u_int=unsigned\ int
#        u_long=unsigned\ long
#        u_short=unsigned\ short
#    )

function(CREATE_RPC_TARGET basename)
    SET(OUTPATH ${RPC_OUTPUT_DIR}/${basename})
    SET(INNAME ${CMAKE_CURRENT_SOURCE_DIR}/${basename}.x)
    MESSAGE(STATUS "Generating rpc rules for ${INNAME}")
    SET(OUTFILES
            ${OUTPATH}.h
            ${OUTPATH}_svc.c
            ${OUTPATH}_xdr.c
            ${OUTPATH}_clnt.c)
    SET(intfiles
            ${OUTPATH}.h
            ${OUTPATH}_svc.c_
            ${OUTPATH}_xdr.c_
            ${OUTPATH}_clnt.c_)
    add_custom_command(OUTPUT ${OUTFILES}
            COMMAND ${CMAKE_COMMAND} -E remove -f ${intfiles}
            COMMAND ${RPCGEN_PROG} ${RPCFLAGS} -h -o ${basename}.h ${INNAME}
            COMMAND ${RPCGEN_PROG} ${RPCFLAGS} -c -o ${basename}_xdr.c_ ${INNAME}
            COMMAND ${RPCGEN_PROG} ${RPCFLAGS} -l -o ${basename}_clnt.c_ ${INNAME}
            COMMAND ${RPCGEN_PROG} ${RPCFLAGS} -m -o ${basename}_svc.c_ ${INNAME}
            COMMAND ${CMAKE_SOURCE_DIR}/src/gds/rpc/cleanrpc ${basename}
            MAIN_DEPENDENCY ${CMAKE_CURRENT_SOURCE_DIR}/${basename}.x
            WORKING_DIRECTORY ${RPC_OUTPUT_DIR}
            )

    SET(libname ${basename}_rpc)
    add_library(${libname} OBJECT
            ${OUTFILES})
    if(APPLE)
        target_compile_options(${libname} PUBLIC -std=gnu99)
        target_compile_definitions(${libname} PUBLIC
                u_int=unsigned\ int
                u_long=unsigned\ long
                u_short=unsigned\ short
                )
    endif()
    target_include_directories(${libname} PUBLIC
            ${DTT_INCLUDES} ${RPC_INCLUDE_DIRS})
    get_property(tmp GLOBAL PROPERTY RPC_OUT_FILES)
    set_property(GLOBAL PROPERTY RPC_OUT_FILES ${tmp} ${OUTFILES} )

    get_property(tmp GLOBAL PROPERTY RPC_TARGETS)
    set_property(GLOBAL PROPERTY RPC_TARGETS ${tmp} ${libname})

endfunction()

function(CREATE_RPC_TARGET_NO_SVC basename)
    SET(OUTPATH ${RPC_OUTPUT_DIR}/${basename})
    SET(INNAME ${CMAKE_CURRENT_SOURCE_DIR}/${basename}.x)
    MESSAGE(STATUS "Generating rpc rules for ${INNAME}")
    SET(OUTFILES
            ${OUTPATH}.h
            #${OUTPATH}_svc.c
            ${OUTPATH}_xdr.c
            ${OUTPATH}_clnt.c)
    SET(intfiles
            ${OUTPATH}.h
            ${OUTPATH}_svc.c_
            ${OUTPATH}_xdr.c_
            ${OUTPATH}_clnt.c_)
    add_custom_command(OUTPUT ${OUTFILES}
            COMMAND ${CMAKE_COMMAND} -E remove -f ${intfiles}
            COMMAND ${RPCGEN_PROG} ${RPCFLAGS} -h -o ${basename}.h ${INNAME}
            COMMAND ${RPCGEN_PROG} ${RPCFLAGS} -c -o ${basename}_xdr.c_ ${INNAME}
            COMMAND ${RPCGEN_PROG} ${RPCFLAGS} -l -o ${basename}_clnt.c_ ${INNAME}
            COMMAND ${RPCGEN_PROG} ${RPCFLAGS} -m -o ${basename}_svc.c_ ${INNAME}
            COMMAND ${CMAKE_SOURCE_DIR}/scripts/cleanrpc ${basename}
            MAIN_DEPENDENCY ${CMAKE_CURRENT_SOURCE_DIR}/${basename}.x
            WORKING_DIRECTORY ${RPC_OUTPUT_DIR}
            )

    SET(libname ${basename}_rpc)
    add_library(${libname} OBJECT
            ${OUTFILES})
    if(APPLE)
        target_compile_options(${libname} PUBLIC -std=gnu99)
        target_compile_definitions(${libname} PUBLIC
                u_int=unsigned\ int
                u_long=unsigned\ long
                u_short=unsigned\ short
                )
    endif()
    target_include_directories(${libname} PUBLIC
            ${DTT_INCLUDES})
    get_property(tmp GLOBAL PROPERTY RPC_OUT_FILES)
    set_property(GLOBAL PROPERTY RPC_OUT_FILES ${tmp} ${OUTFILES} )

    get_property(tmp GLOBAL PROPERTY RPC_TARGETS)
    set_property(GLOBAL PROPERTY RPC_TARGETS ${tmp} ${libname})

endfunction(CREATE_RPC_TARGET_NO_SVC)

add_subdirectory(awgtpman)
add_subdirectory(rpc)

=== src/include/CMakeLists.txt ===

install(FILES
            daq_core.h
            daq_core_defs.h
            daq_data_types.h
            portableInline.h
            daqmap.h
        DESTINATION
            include/advligorts
        )


add_subdirectory(drv)
add_subdirectory(util)

## advligorts 3.4~rc0

=== debian/changelog ===
advligorts (3.4~rc0-1) unstable; urgency=medium

  * Initial packaging.

 -- Jameson Graef Rollins <jameson.rollins@ligo.org>  Tue, 22 Aug 2017 15:21:27 -0700

=== debian/control ===
Source: advligorts
Section: science
Priority: optional
Maintainer: Jameson Graef Rollins <jameson.rollins@ligo.org>
Build-Depends:
 cmake,
 bison,
 debhelper (>= 9),
 dkms,
 epics-dev,
 flex,
 grace,
 ldas-tools-al-dev,
 ldas-tools-framecpp-dev,
 libbz2-dev,
 libc-dev-bin,
 libmotif-dev,
 libtool,
 libxpm-dev,
 libxt-dev,
 libzmq3-dev,
 mx,
 open-mx,
 pkg-config,
Standards-Version: 3.9.6
Vcs-Svn: https://redoubt.ligo-wa.caltech.edu/svn/advLigoRTS

Package: advligorts-mbuf-dkms
Architecture: any
Depends:
 advligorts-module-support,
 ${misc:Depends},
 ${shlibs:Depends},
Description: advLigoRTS mbuf kernel module
 Core component of advLigoRTS.
 .
 Memory buffer kernel module.

Package: advligorts-symmetricom-dkms
Architecture: any
Depends:
 advligorts-module-support,
 ${misc:Depends},
 ${shlibs:Depends},
Description: advLigoRTS symmetricom kernel module
 Core component of advLigoRTS.
 .
 GPS card interface kernel module.

Package: advligorts-module-support
Architecture: all
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: advLigoRTS kernel module support
 Core component of advLigoRTS.
 .
 Kernel module device creation scripts.

Package: advligorts-daqd
Architecture: any
Depends:
 advligorts-symmetricom-dkms,
 ${misc:Depends},
 ${shlibs:Depends},
Description: advLigoRTS daqd binaries
 Core component of advLigoRTS.
 .
 This package installs all daqd components:
  * daqd_dc_mx: data concentrator
  * daqd_bcst: frame broadcaster
  * daqd_fw: frame writer
  * daqd_rcv: NDS1 server
  * daqd_mxsymm: all-in-one mx receiver systems
  * daqd_standiop: daqd for stand-alone systems
  * nds: archive data retriever for NDS1

Package: advligorts-front-end
Architecture: any
Depends:
 advligorts-mbuf-dkms,
 advligorts-symmetricom-dkms,
 linux-image-3.2.88-csp,
 ${misc:Depends},
 ${shlibs:Depends},
Description: advLigoRTS front-end binaries
 Core component of advLigoRTS.
 .
 Binaries for the front ends (awgtpman, mx_stream).

Package: advligorts-rcg-support
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: advLigoRTS real-time code generator (RCG) support scripts
 Core component of advLigoRTS.
 .
 Support scripts for the RCG.

Package: advligorts-cymac
Architecture: all
Depends:
 advligorts-daqd,
 advligorts-front-end,
 advligorts-rcg-support,
 cds-workstation,
 dataviewer,
 ${misc:Depends},
Description: advLigoRTS stand-alone "cymac" metapackage
 Advanced LIGO data acquisition system, stand-alone version.

Package: dataviewer
Architecture: any
Depends:
 grace,
 ${misc:Depends},
 ${shlibs:Depends},
Description: NDS1 dataviewer application
 GUI application to view time series data from NDS1 servers.

=== debian/rules ===
#!/usr/bin/make -f

SVERSION := $(shell dpkg-parsechangelog --show-field=Version | rev | cut -d- -f2- | rev)

%:
	dh $@ --builddirectory=build --with dkms


install-mbuf:
	dh_installdirs -padvligorts-mbuf-dkms usr/src/mbuf-$(SVERSION)
	dh_installdirs -padvligorts-mbuf-dkms lib/udev/rules.d
	dh_installdirs -padvligorts-mbuf-dkms usr/lib/modules-load.d
	install --mode=644 -t debian/advligorts-mbuf-dkms/usr/src/mbuf-$(SVERSION) src/drv/mbuf/*
	sed 's|__SHARE__|/usr/share/advligorts-module-support|' <setup/udev/mbuf.rules >debian/advligorts-mbuf-dkms/lib/udev/rules.d/60-mbuf.rules
	echo mbuf > debian/advligorts-mbuf-dkms/usr/lib/modules-load.d/mbuf.conf

install-symmetricom:
	dh_installdirs -padvligorts-symmetricom-dkms usr/src/symmetricom-$(SVERSION)/drv/symmetricom
	dh_installdirs -padvligorts-symmetricom-dkms usr/src/symmetricom-$(SVERSION)/include/drv
	dh_installdirs -padvligorts-symmetricom-dkms lib/udev/rules.d
	dh_installdirs -padvligorts-symmetricom-dkms usr/lib/modules-load.d
	install --mode=644 -t debian/advligorts-symmetricom-dkms/usr/src/symmetricom-$(SVERSION)/drv/symmetricom src/drv/symmetricom/*
	install --mode=644 -t debian/advligorts-symmetricom-dkms/usr/src/symmetricom-$(SVERSION)/include/drv src/include/drv/*
	install --mode=644 -t debian/advligorts-symmetricom-dkms/usr/src/symmetricom-$(SVERSION)/include/ src/include/proc.h
	sed 's|__SHARE__|/usr/share/advligorts-module-support|' <setup/udev/symmetricom.rules >debian/advligorts-symmetricom-dkms/lib/udev/rules.d/60-symmetricom.rules
	echo symmetricom > debian/advligorts-symmetricom-dkms/usr/lib/modules-load.d/symmetricom.conf


override_dh_auto_configure:
	mkdir -p build
	(cd build && cmake -DCMAKE_INSTALL_PREFIX=$(DESTDIR)/usr ..)

override_dh_install: install-symmetricom install-mbuf
	dh_install

override_dh_dkms:
	dh_dkms -V $(SVERSION)

override_dh_auto_test:
	true

override_dh_clean:
	rm -rf build

## advligorts 5.5.2

=== debian/changelog ===
advligorts (5.5.2-1+deb10) stable; urgency=medium

  * release 5.5.2

 -- Erik von Reis <evonreis@caltech.edu>  Thu, 20 Nov 2025 14:48:48 -0800

advligorts (5.5.2~dev1-1+deb10) stable; urgency=medium

  * Fixing LIGO DAC instance number choice, and updating a few DAC related medms
  * Center OUTPUT lable on DAC overvire medm
  * wait longer for LIGO DAC timing sync
  * Change color of LIGO DAC for better visability
  * Remove extra DACs from selection list, set card_num to -1 to force people to pick a valid card_num
  * Remove filter reset dmesg

 -- Erik von Reis <evonreis@caltech.edu>  Wed, 19 Nov 2025 11:45:00 -0800

advligorts (5.5.1~dev1-1+deb10) stable; urgency=medium

  * Extending standalone_edcu to be able to publish data via the pub_sub interface.

 -- Erik von Reis <evonreis@caltech.edu>  Thu, 31 Jul 2025 09:06:49 -0700

advligorts (5.5.0-4+deb10) stable; urgency=medium

  * Change location for example daqd-rc

 -- Erik von Reis <evonreis@caltech.edu>  Wed, 18 Jun 2025 17:01:09 -0700

advligorts (5.5.0-3+deb10) stable; urgency=medium

  * Fix bad path in install file

 -- Erik von Reis <evonreis@caltech.edu>  Wed, 18 Jun 2025 14:33:33 -0700

advligorts (5.5.0-2+deb10) stable; urgency=medium

  * Add example daqdrc file to /usr/lib/advligorts-daqd

 -- Erik von Reis <evonreis@caltech.edu>  Wed, 18 Jun 2025 14:10:00 -0700

advligorts (5.5.0-1+deb10) stable; urgency=medium

  * Set version to 5.5.0 release

 -- Erik von Reis <evonreis@caltech.edu>  Wed, 07 May 2025 15:53:20 -0700

advligorts (5.5.0~dev2-1+deb10) stable; urgency=medium

  * Update fe_simulated_streams to be able to run faster than realtime.
  * correct 20-bit DAC duotone multiplier
  * Fix DACs so that they don't run empty in a slow IOP.
  * Add extra_dac_delay_cycles
  * Get LIGO DAC duotone working
  * Better example IOP models

 -- Erik von Reis <evonreis@caltech.edu>  Fri, 25 Apr 2025 15:50:31 -0700

advligorts (5.5.0~dev1-1+deb10) stable; urgency=medium

  * Adding phase rotator part python examples
  * Fixing state space not showing up in CDS_PARTS
  * Adding noise parts to unittest model and new example script
  * librts: avoid feeding daq config file to fmseq.pl
  * GPSTIME driver: offset script auto calculates gps offset based on measured delta
  * fix userspace build for param no_zero_pad=1
  * Fixing deb10 build with statespace, and librts builds
  * Making it so enable_sdk.sh won't overwrite CDS_SRC if already set.
  * Updating daqd declarative config
  * Remove or comment out log messages in nds that end up being line noise.
  * Update to a test test_daqd_stop_on_duplicate_channel_list to reflect how fe_simulated_streams works
  * duotone changes from 5.1
  * Fixing DacKillIop part
  * Adding better duoToneMultiplier for LIGO DAC

 -- Erik von Reis <evonreis@caltech.edu>  Mon, 14 Apr 2025 13:03:03 -0700

advligorts (5.4.0-1+deb10) stable; urgency=medium

  * Bump version to 5.4.0 release

 -- Erik von Reis <evonreis@caltech.edu>  Sun, 03 Nov 2024 13:50:06 -0800

advligorts (5.4.0~dev1-1+deb10) stable; urgency=medium

  * Added atan part and unittest
  * Added phase unwrap part
  * Fix timing light when using newer firmware versions on Ligo timing card.
  * Using hash of sdk path, instead of rcg-local for version when enabling SDK with script
  * renaming rcg_version -> rcg-version to match installed dir, and fix warning from rtcds
  * Add enable_sdk script update local rcg-version
  * Fixed librts parse of the filters
  * Mark rcg-version file so enabling the SDK dose not make tracked changes to it
  * Fixing issue where when a user model does not find at least one usable ADC, it crashes the FE when removed.
  * Translated Pub_sub, Local-dc,and run_number tests from bash to python.
  * testpoint and awg RPC services now run on a single server, therefore a single thread
  * Adding librts example script for phase unwrap part
  * Switch order so that IOP prefers Ligo Timing Card to old TDS system
  * Statespace part working in librts, and RT models building it in.
  * Adding statespace part to x1tst.mdl model, and writing out x1iopvirt.mdl with 2019a
  * Adding new LIGO 32 chan DAC to the RCG/RTS, based on branch 5.1
  * Updating fe_simulated_stream to run without a GPS driver loaded.
  * IOP waits for intermittent late DAC data
  * Improved sys access to LPTC registers
  * Fixing race condition when two models share a DAC, and one is late, the IOP can miss data and won't report anything went wrong.
  * Temperature monitoring added to LIGO timing card.
  * improve ipc_channel_report.py to show when all IPC checks are passed.
  * Adding mfence ops for userspace
  * fix: 18-bit DACs wouldn't set DAC error bit when in HIQTR
  * Add build option to make building some binaries easier on bootservers
  * Starting to add support for other ADC types in virtual IO
  * Fixing a bug with multiple DACs in your model having the same card_num, fixing ADC top level check
  * Fixing issue where VIO did not clean up its mbufs
  * Fixing issue where VIO IOPs did not write correct time/cycle for AWG
  * Fixing issue where fast ADC would report slow ADC data in VIO mode
  * Fixing undersample use in VIO mode.
  * Added dolphin timing xmit indicator
  * Adding  IPX TX status, and warning when IPC send takes too long
  * Fix #655 detect duplicate channels when starting the DAQ, then crash
  * Adding sync code, to re-sync ADCs on startup
  * Allow for longer pulse widths on the PPS to be valid
  * Small change to not call time shift code when we don't have an IO chassis
  * Adding error message when testpoint_server unexpectedly returns
  * change daq_wiper.py to work for test stands by default. Move IFO one to daq_wiper_ifo.py

 -- Erik von Reis <evonreis@caltech.edu>  Thu, 31 Oct 2024 12:13:22 -0700

advligorts (5.2.1~dev1-1+deb10) stable; urgency=medium

  [ ezekiel.dohmen ]
  * Fixing packaging issue, and shipping cds-shmem directory with rcg install
